PROGRAM_NAME='JON01, RGB Spectrum Superview Block'
(*   DATE:09/15/00    TIME:15:13:49    *)
(***********************************************************)
(* System Type :                                           *)
(***********************************************************)
(* Rev3: 1. Add"Maximize"button(200)                       *)
(*       2. Add PanUp/Down/Left/Rightbuttons               *)
(*                                                         *)
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

SuperView   = 32:1:1     (* 232 : 9600,n,8,1 *)
TP          = 192:1:0
(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT


TRUE             = 1
FALSE            = 0

PIXEL_JUMP       = 20

(* HOST Commands *)
CLEAR_HOST_LIST  = 1
HOST             = 2
HOST_DELETE      = 3
HOST_INTERACTIVE = 4
HOST_LIST        = 5
HOST_LOAD        = 6
HOST_NAME        = 7
HOST_SAVE        = 8
HOST_TIMING      = 9

(* RGB Input Commands *)
RGB_INPUT        = 11
RGB_INPUT_DELETE = 12
RGB_INPUT_INTERACTIVE  = 13
RGB_INPUT_LIST   = 14
RGB_INPUT_LOAD   = 15
RGB_INPUT_NAME   = 16
RGB_INPUT_SAVE   = 17
RGB_INPUT_TIMING = 18

(* Window Positioning/Visibility *)
ASPECT_RATIO_TRIM= 21
ED               = 22
MWSR             = 23
PDR              = 24
PRIORITY         = 25
PRIORITY_ALL     = 26
PSR              = 27
WDR              = 28
SET_WINDOW       = 29
SET_WINDOW_ALL   = 30
WSR              = 31

(* Image Control *)
BRIGHT           = 41
CHROMA_KEY       = 42
CHROMAKEY_COLOR  = 43
CONTRAST         = 44
FREEZE           = 45
GAMA             = 46
HUE              = 47
INPUT            = 48
MOTION_FILTER    = 49
SATURATION       = 50

(* Serial Port Functions *)
BAUD_RATE        = 51
ECHO             = 52

SETUP            = 53

(* Misc Commands *)
DEMO             = 61
FRONT_PANEL      = 62
HELP             = 63
ID               = 64
RESTORE_DEFAULT  = 65
INPUT_ADJUST     = 66

BRIGHT_DARK      = 67
BRIGHT_LIGHT     = 68

RESIZE           = 1
MOVE_LEFT        = 2
MOVE_RIGHT       = 3
MOVE_UP          = 4
MOVE_DOWN        = 5
ZOOM_IN          = 6
ZOOM_OUT         = 7
MOVE_WINDOW_UP   = 100
MOVE_WINDOW_DOWN = 101
MOVE_WINDOW_LEFT = 102
MOVE_WINDOW_RIGHT= 103
RESIZE_BIG_4TO3  = 104
RESIZE_SMALL_4TO3= 105
RESIZE_BIG_16TO9 = 106
RESIZE_SMALL_16TO9 = 107

TOTAL_WINDOWS    = 4

(* Indexes for SETTINGS array *)
OUTPUT           = 1

(* TYPE INDEXES *)
WDR_X_POS        = 1
WDR_Y_POS        = 2
WDR_WIDTH        = 3
WDR_HEIGHT       = 4
WSR_X_POS        = 5
WSR_Y_POS        = 6
WSR_WIDTH        = 7
WSR_HEIGHT       = 8
INPUT_TYPE       = 9   (* COMPOSITE, RGB, SVID *)
INPUT_RES_WIDTH  = 10
INPUT_RES_HEIGHT = 11
OUTPUT_RES_WIDTH = 12
OUTPUT_RES_HEIGHT= 13

(* INPUT TYPES *)
COMPOSITE        = 1
RGB              = 2
SVID             = 3

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

SV_BUFFER[255]
SV_STRING[255]
WIDTH
HEIGHT
X_COORD
Y_COORD
OLD_WSR_WIDTH
OLD_WSR_HEIGHT
X_POS
Y_POS

OLD_WSR[6][20]

STR[70]

X_LEVEL
Y_LEVEL
PRESET

WINDOW
LAST_COMMAND[6]
FRZ[6]
BRI_LEVEL[6][10]
DATA_STR[70]
INTEGER SETTINGS[10][30] (* INDEXES [WINDOW][SETTING] *)

ACTION
MOVE_X
MOVE_Y
MOVE_BRI
MOVE_CONTRAST
MOVE_SATURATION
MOVE_HUE


WINDOW_MODE[6]
RGB_CHANNEL[6]

X
X_CONTRAST
TOTAL_WIDTH
TOTAL_HEIGHT
SINGLE_WIDTH
SINGLE_HEIGHT
MAIN_WIDTH
MAIN_HEIGHT
(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*           SUBROUTINE DEFINITIONS GO BELOW               *)
(***********************************************************)
DEFINE_CALL 'SVWIN00F' (DEV DEVICE,FUNC,DATA[50],OFFSET)
LOCAL_VAR CMD_STR[59]
{
  SELECT
  {
     ACTIVE (FUNC = HOST):
     {
        IF (LENGTH_STRING(DATA))
           CMD_STR = "'HOST ',DATA,13"
        ELSE
           CMD_STR = "'HOST',13"
        (* DATA = 'AUTO' or 'FREE' or 'LOCK' *)
     }
     ACTIVE (FUNC = MWSR) :
     {
        CMD_STR = "'MWSR ',DATA,13"
        (* DATA = <WINDOW#> <X> <Y> <WIDTH> <HEIGHT> *)
     }
     ACTIVE (FUNC = WSR) :
     {
        CMD_STR = "'WSR ',DATA,13"
        (* DATA = <WINDOW#> <X> <Y> <WIDTH> <HEIGHT> *)
     }
     ACTIVE (FUNC = WDR) :
     {
        (* DATA = <WINDOW#> <X> <Y> <WIDTH> <HEIGHT> or
           DATA = <WINDOW#> *)
        CMD_STR = "'WDR ',DATA,13"
     }
     ACTIVE (FUNC = PDR) :
     {
        (* DATA = <WINDOW#> <X> <Y> <WIDTH> <HEIGHT> or
           DATA = <WINDOW#> *)
        CMD_STR = "'PDR ',DATA,13"
     }
     ACTIVE (FUNC = PSR) :
     {
        (* DATA = <WINDOW#> <X> <Y> <WIDTH> <HEIGHT> or
           DATA = <WINDOW#> *)
        CMD_STR = "'PSR ',DATA,13"
     }
     ACTIVE (FUNC = ED) :
     {
        (* DATA = <WINDOW#> <1..6> *)
        CMD_STR = "'ED ',DATA,13"
     }
     ACTIVE (FUNC = PRIORITY) :
     {
        (* DATA = <WINDOW#> <1..6> *)
        CMD_STR = "'PRI ',DATA,13"
     }
     ACTIVE (FUNC = PRIORITY_ALL) :
     {
        (* DATA = <ALL> <1..6> <1..6> <1..6> <1..6> <1..6> <1..6> *)
        CMD_STR = "'PRI ALL ',DATA,13"
     }
     ACTIVE (FUNC = SET_WINDOW) :
     {
        (* DATA = <WINDOW#> <ON/OFF> *)
        CMD_STR = "'win ',DATA,13"
     }
     ACTIVE (FUNC = SET_WINDOW_ALL) :
     {
        (* DATA = <ON/OFF> *)
        CMD_STR = "'win all ',DATA,13"
     }
     ACTIVE (FUNC = FREEZE) :
     {
        (* DATA = <WINDOW#> <ON/OFF> *)
        CMD_STR = "'freeze ',DATA,13"
     }
     ACTIVE (FUNC = ECHO) :
     {
        (* DATA = <ON/OFF> *)
        CMD_STR = "'ECHO ',DATA,13"
     }
     ACTIVE (FUNC = RGB_INPUT) :
     {
        (* DATA = <WINDOW #> *)
        CMD_STR = "'RGBinput ',DATA,13"
     }
     ACTIVE (FUNC = BRIGHT) :
     {
        (* DATA = <WINDOW#> <BRIGHTNESS#> 
           DATA = <WINDOW#> *)
        CMD_STR = "'BRI ',DATA,13"
     }
     ACTIVE (FUNC = CONTRAST) :
     {
        (* DATA = <WINDOW#> <CONTRAST#> 
           DATA = <WINDOW#> *)
        CMD_STR = "'CONT ',DATA,13"
     }
     ACTIVE (FUNC = SATURATION) :
     {
        (* DATA = <WINDOW#> <SATURATION#> 
           DATA = <WINDOW#> *)
        CMD_STR = "'SAT ',DATA,13"
     }
     ACTIVE (FUNC = HUE) :
     {
        (* DATA = <WINDOW#> <HUE#> 
           DATA = <WINDOW#> *)
        CMD_STR = "'HUE ',DATA,13"
     }
  }
  SEND_STRING DEVICE,CMD_STR
  IF ([DEVICE,250])                (* !!REV1 TX DEBUG *)
    SEND_STRING 0,"'-> DEV',ITOA(DEVICE),': ',CMD_STR,10"

  OFFSET = OFFSET
}
DEFINE_CALL 'Setup Coords' (WIN,_X,_Y,_W,_H,DATA[70])
{
     DATA = "ITOA(WIN),' ',ITOA(_X),' ',ITOA(_Y),' ',
                           ITOA(_W),' ',ITOA(_H)"
}
DEFINE_CALL 'SLIDE WINDOW LEFT' (DEV DEVICE,WIN) (* MOVE WINDOW LEFT *)
{
       SETTINGS[WIN][WDR_X_POS] = SETTINGS[WIN][WDR_X_POS]-PIXEL_JUMP
       CALL 'Setup Coords' (WIN,SETTINGS[WIN][WDR_X_POS],SETTINGS[WIN][WDR_Y_POS],
                                   SETTINGS[WIN][WDR_WIDTH],SETTINGS[WIN][WDR_HEIGHT],DATA_STR)
       CALL 'SVWIN00F' (DEVICE,WDR,"DATA_STR",0)
}

DEFINE_CALL 'SLIDE WINDOW RIGHT' (DEV DEVICE,WIN) (* MOVE WINDOW RIGHT *)
{
       SETTINGS[WIN][WDR_X_POS] = SETTINGS[WIN][WDR_X_POS]+PIXEL_JUMP
       CALL 'Setup Coords' (WIN,SETTINGS[WIN][WDR_X_POS],SETTINGS[WIN][WDR_Y_POS],
                                   SETTINGS[WIN][WDR_WIDTH],SETTINGS[WIN][WDR_HEIGHT],DATA_STR)
       CALL 'SVWIN00F' (DEVICE,WDR,"DATA_STR",0)
}
DEFINE_CALL 'RESIZE BIGGER 4TO3' (DEV DEVICE, WIN)
{
  SETTINGS[WIN][WDR_WIDTH]  = SETTINGS[WIN][WDR_WIDTH]+PIXEL_JUMP 
  SETTINGS[WIN][WDR_HEIGHT] = ((SETTINGS[WIN][WDR_WIDTH] * 3) / 4)
  CALL 'Setup Coords' (WIN,SETTINGS[WIN][WDR_X_POS],SETTINGS[WIN][WDR_Y_POS],
                              SETTINGS[WIN][WDR_WIDTH],SETTINGS[WIN][WDR_HEIGHT],DATA_STR)
  CALL 'SVWIN00F' (DEVICE,WDR,"DATA_STR",0)
}

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

SEND_COMMAND SuperView,'SET BAUD 9600,N,8,1'
(* SEND_COMMAND SuperView,'HOST FREE' (* Set SuperView to Free-Run Mode *) *)

CREATE_BUFFER SuperView,SV_BUFFER

CREATE_LEVEL TP,1,X_LEVEL
CREATE_LEVEL TP,2,Y_LEVEL
CREATE_LEVEL TP,3,MOVE_BRI
CREATE_LEVEL TP,4,MOVE_CONTRAST
CREATE_LEVEL TP,5,MOVE_SATURATION
CREATE_LEVEL TP,6,MOVE_HUE

IF (!LENGTH_STRING(WINDOW_MODE))   (* Set To Pan Mode *)
  WINDOW_MODE = "1,1,1,1,1,1"

WAIT 20
{
  WINDOW = 0
  CALL 'SVWIN00F' (SuperView,HOST,"",0)
  CALL 'SVWIN00F' (SuperView,ECHO,'ON',0)
}

WAIT 10 SEND_COMMAND TP,'PAGE-Main Page'
(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM


PUSH[TP,17]                        (* LOGO *)
{
  (* Get Resolution *)
  WINDOW = 0
  ACTION = HOST_LIST
  CLEAR_BUFFER SV_BUFFER
  CALL 'SVWIN00F' (SuperView,HOST,"",0)
  WAIT 10
  {
    WINDOW = 1
    ACTION = SETUP
    WAIT 21
    {
      WINDOW = 2
      ACTION = SETUP
      WAIT 21
      {
        WINDOW = 3
        ACTION = SETUP
        WAIT 21
        {
          WINDOW = 4
          ACTION = SETUP
          WAIT 21
          {
            WINDOW = 5
            ACTION = SETUP
            WAIT 21
            {
              WINDOW = 6
              ACTION = SETUP
              WAIT 20 SEND_COMMAND TP,'PAGE-Controls'
            }
          }
        }
      }
    }  
  }
}


IF (WINDOW && ACTION = SETUP)
{
      ACTION = 0
      CALL 'SVWIN00F' (SuperView,WDR,"ITOA(WINDOW)",0)
      CALL 'SVWIN00F' (SuperView,WSR,"ITOA(WINDOW)",0)
      
      WAIT 10 (* WDR VALUES *)
      {
       X = FIND_STRING(SV_BUFFER,'WDR',1)      
       IF (X)
       {
        SV_STRING = MID_STRING(SV_BUFFER,X+5,30)
        STR = REMOVE_STRING(SV_STRING,' ',1)
        X_COORD = ATOI(STR)
        STR = REMOVE_STRING(SV_STRING,' ',1)
        Y_COORD = ATOI(STR)
        STR = REMOVE_STRING(SV_STRING,' ',1)
        WIDTH   = ATOI(STR)
        STR = REMOVE_STRING(SV_STRING,' ',1)
        HEIGHT  = ATOI(STR)
        LAST_COMMAND[WINDOW] = WSR

        SETTINGS[WINDOW][WDR_X_POS] = X_COORD
        SETTINGS[WINDOW][WDR_Y_POS] = Y_COORD
        SETTINGS[WINDOW][WDR_WIDTH] = WIDTH
        SETTINGS[WINDOW][WDR_HEIGHT] = HEIGHT
       }
       (* WSR VALUES *)
       X = FIND_STRING(SV_BUFFER,'WSR',1)
       IF (X)
       {
        SV_STRING = MID_STRING(SV_BUFFER,X+5,30)

        STR = REMOVE_STRING(SV_STRING,' ',1)
        X_POS = ATOI(STR)
        STR = REMOVE_STRING(SV_STRING,' ',1)
        Y_POS = ATOI(STR)
        STR = REMOVE_STRING(SV_STRING,' ',1)
        OLD_WSR_WIDTH   = ATOI(STR)
        STR = REMOVE_STRING(SV_STRING,' ',1)
        OLD_WSR_HEIGHT  = ATOI(STR)
        LAST_COMMAND[WINDOW] = RGB_INPUT
      
        SETTINGS[WINDOW][WSR_X_POS] = X_POS
        SETTINGS[WINDOW][WSR_Y_POS] = Y_POS
        SETTINGS[WINDOW][WSR_WIDTH] = WSR_WIDTH
        SETTINGS[WINDOW][WSR_HEIGHT] = WSR_HEIGHT
      
        CALL 'SVWIN00F' (SuperView,RGB_INPUT,"ITOA(WINDOW)",0)
       }
      }
      WAIT 15 (* INPUT TYPE *)
      {
       IF (FIND_STRING(SV_BUFFER,'Not an RGB channel',1))
       {
         (* SHOULD DETERMINE INPUT TYPE IF NOT AN RGB CHANNEL *)
         SETTINGS[WINDOW][INPUT_TYPE] = FALSE
         RGB_CHANNEL[WINDOW] = FALSE
       }
       ELSE
       IF (FIND_STRING(SV_BUFFER,'MODE',1))
       {
        SV_STRING = SV_BUFFER
        REMOVE_STRING(SV_STRING, 'IL', 1)
        SETTINGS[WINDOW][INPUT_RES_WIDTH] = ATOI(MID_STRING(SV_STRING,34,5))
        SETTINGS[WINDOW][INPUT_RES_HEIGHT] = ATOI(MID_STRING(SV_STRING,49,5))
        SETTINGS[WINDOW][INPUT_TYPE] = RGB
        RGB_CHANNEL[WINDOW] = TRUE
       }
       CLEAR_BUFFER SV_BUFFER
       CALL 'SVWIN00F' (SuperView,ECHO,'ON',0) (* SV BUFFER DOESN'T WORK RIGHT IF IT IS EMPTY *)
      }
}

IF (WINDOW && LAST_COMMAND[WINDOW] = FREEZE)
   {
      STR = UPPER_STRING(SV_STRING)
      IF (FIND_sTRING(STR,'ON',1))
      {
        FRZ[WINDOW] = 0
        CALL 'SVWIN00F' (SuperView,FREEZE,"ITOA(WINDOW),' OFF'",0)
        LAST_COMMAND[WINDOW] = 0
      }
      ELSE IF (FIND_STRING(STR,'OFF',1))
      {
        FRZ[WINDOW] = 1
        CALL 'SVWIN00F' (SuperView,FREEZE,"ITOA(WINDOW),' ON'",0)
        LAST_COMMAND[WINDOW] = 0
      }
   }
   
SELECT 
{
   ACTIVE (ACTION = HOST_LIST) :
   {
(* SV_BUFFER = 
MODE free
AUTOSYNC_STATE disable
NAME              HFP HS  HBP HACT VFP VS VB(START1)P VACT HFREQ SYNC HPOL VPOL IL
sgi 1280x1024  60 30  120 250 128(START2)0 3   3  35  1024 63901 3    0    0    0 *)
      WAIT 5
      IF (FIND_STRING(SV_BUFFER,'HFREQ',1))
      {
        SV_STRING = SV_BUFFER
        REMOVE_STRING(SV_STRING, 'IL', 1)
        
        SETTINGS[OUTPUT][OUTPUT_RES_WIDTH]  = ATOI(MID_STRING(SV_STRING,34,5))
        SETTINGS[OUTPUT][OUTPUT_RES_HEIGHT] = ATOI(MID_STRING(SV_STRING,49,5))

        STR = "ITOA(SETTINGS[OUTPUT][OUTPUT_RES_WIDTH]), 'X', ITOA(SETTINGS[OUTPUT][OUTPUT_RES_HEIGHT])"
        SEND_COMMAND TP,"'!T',1,STR"

        TOTAL_WIDTH = SETTINGS[OUTPUT][OUTPUT_RES_WIDTH]
        TOTAL_HEIGHT= SETTINGS[OUTPUT][OUTPUT_RES_HEIGHT]
        
        SINGLE_WIDTH = TOTAL_WIDTH / (TOTAL_WINDOWS - 1)
        SINGLE_HEIGHT= TOTAL_HEIGHT/ (TOTAL_WINDOWS - 1)
        
        MAIN_WIDTH   = TOTAL_WIDTH  - SINGLE_WIDTH
        MAIN_HEIGHT  = TOTAL_HEIGHT - SINGLE_HEIGHT
        ACTION = 0 
      }
   }
   ACTIVE (ACTION = INPUT_ADJUST) :
   {
      WAIT 10
      
(*      BRI_LEVEL[WINDOW] = ATOI(SV_BUFFER[1]) 
      SEND_COMMAND TP,"'!T',2,'TEST'" *)
      ACTION = 0
   }
   ACTIVE (1) :
   {
      IF (FIND_STRING(UPPER_STRING(SV_STRING),'ERROR',1))
      {
      }
   }
}

(* Select Window *)

PUSH[TP,1]                         (* Window 1 *)
  WINDOW = 1
PUSH[TP,2]                         (* Window 2 *)
  WINDOW = 2
PUSH[TP,3]                         (* Window 3 *)
  WINDOW = 3
PUSH[TP,4]                         (* Window 4 *)
  WINDOW = 4

PUSH[TP,1]
PUSH[TP,2]
PUSH[TP,3]
PUSH[TP,4]
{
  CALL 'SVWIN00F' (SuperView,SET_WINDOW,"ITOA(WINDOW),' ON'",0)

  STR = "ITOA(SETTINGS[WINDOW][WDR_X_POS]),',',ITOA(SETTINGS[WINDOW][WDR_Y_POS]),',',ITOA(SETTINGS[WINDOW][WDR_WIDTH]),',',ITOA(SETTINGS[WINDOW][WDR_HEIGHT])"
  SEND_COMMAND TP,"'!T',3,STR"
  STR = "ITOA(SETTINGS[WINDOW][WSR_X_POS]),',',ITOA(SETTINGS[WINDOW][WSR_Y_POS]),',',ITOA(SETTINGS[WINDOW][WSR_WIDTH]),',',ITOA(SETTINGS[WINDOW][WSR_HEIGHT])"
  SEND_COMMAND TP,"'!T',4,STR"
  STR = "ITOA(SETTINGS[WINDOW][INPUT_RES_WIDTH]),' X ',ITOA(SETTINGS[WINDOW][INPUT_RES_HEIGHT])"
  SEND_COMMAND TP,"'!T',5,STR"

}
[TP,1] = (WINDOW = 1)
[TP,2] = (WINDOW = 2)
[TP,3] = (WINDOW = 3)
[TP,4] = (WINDOW = 4)

PUSH[TP,5]                         (* Priority *)
{
  PULSE [TP,5]
  LAST_COMMAND[WINDOW] = PRIORITY
  CALL 'SVWIN00F' (SuperView,PRIORITY,"ITOA(WINDOW),' 1'",0)
}
PUSH[TP,8]                         (* FREEZE *)
{
  LAST_COMMAND[WINDOW] = FREEZE
  CALL 'SVWIN00F' (SuperView,FREEZE,"ITOA(WINDOW)",0)
}
[TP,8] = (WINDOW && FRZ[WINDOW] = 1)


PUSH[TP,9]                         (* Position *)
{
  LAST_COMMAND[WINDOW] = WSR
  CALL 'SVWIN00F' (SuperView,WSR,"ITOA(WINDOW)",0)
}

PUSH[TP,10]                        (* PAN Mode *)
IF (WINDOW)
{
  WINDOW_MODE[WINDOW] = 1
}
PUSH[TP,11]                        (* ZOOM Mode *)
IF (WINDOW)
{
  WINDOW_MODE[WINDOW] = 2
}
[TP,10] = (WINDOW_MODE[WINDOW] = 1)
[TP,11] = (WINDOW_MODE[WINDOW] = 2)
[TP,15] = (WINDOW_MODE[WINDOW] = 2)
[TP,16] = (WINDOW_MODE[WINDOW] = 2)

SELECT
{
  ACTIVE (WINDOW && WINDOW_MODE[WINDOW] = 1) :    (* PAN *)
  {
    PUSH[TP,6]                     (* UP *)
      ACTION = MOVE_UP
    [TP,6] = (ACTION = MOVE_UP)
    PUSH[TP,7]                     (* Down *)
      ACTION = MOVE_DOWN
    [TP,7] = (ACTION = MOVE_DOWN)

    PUSH[TP,14]                    (* LEFT *)
      ACTION = MOVE_LEFT
    [TP,14]= (ACTION = MOVE_LEFT)
    PUSH[TP,13]                    (* RIGHT *)
      ACTION = MOVE_RIGHT
    [TP,13]= (ACTION = MOVE_RIGHT)


    PUSH[TP,26]                    (* Tilt UP *)
      ACTION = MOVE_UP
    [TP,26]= (ACTION = MOVE_UP)
    PUSH[TP,27]                    (* Tilt Down *)
      ACTION = MOVE_DOWN
    [TP,27]= (ACTION = MOVE_DOWN)

    RELEASE[TP,6]
    RELEASE[TP,7]
    RELEASE[TP,13]
    RELEASE[TP,14]
    RELEASE[TP,26]
    RELEASE[TP,27]
      ACTION = 0
  }
  ACTIVE (WINDOW && WINDOW_MODE[WINDOW] = 2) :    (* ZOOM *)
  {
    PUSH[TP,6]                     (* ZOOM IN *)
     ACTION = ZOOM_IN
    [TP, 6]= (ACTION = ZOOM_IN)
    PUSH[TP,7]                     (* ZOOM OUT *)
     ACTION = ZOOM_OUT
    [TP, 7]= (ACTION = ZOOM_OUT)
    PUSH[TP,14]                    (* LEFT *)
      ACTION = MOVE_LEFT
    [TP,14]= (ACTION = MOVE_LEFT)
    PUSH[TP,13]                    (* RIGHT *)
      ACTION = MOVE_RIGHT
    [TP,13]= (ACTION = MOVE_RIGHT)


    PUSH[TP,26]                    (* Tilt UP *)
      ACTION = MOVE_UP
    [TP,26]= (ACTION = MOVE_UP)
    PUSH[TP,27]                    (* Tilt Down *)
      ACTION = MOVE_DOWN
    [TP,27]= (ACTION = MOVE_DOWN)

    RELEASE[TP,6]
    RELEASE[TP,7]
    RELEASE[TP,13]
    RELEASE[TP,14]
    RELEASE[TP,26]
    RELEASE[TP,27]
     ACTION = 0
  }
}

PUSH[TP,12]                        (* Touch Bargraph *)
IF (WINDOW)
{
  ACTION = RESIZE

}
RELEASE[TP,12]                     (* Rlease BarGraph *)
IF (WINDOW)
{
  ACTION = 0
  LAST_COMMAND[WINDOW] = WDR
  CALL 'SVWIN00F' (SuperView,WDR,"ITOA(WINDOW)",0)
  SEND_COMMAND TP,"'!T',2,ITOA(X_COORD)"
}

IF (WINDOW)
{
  SELECT
  {
     ACTIVE (ACTION = RESIZE) :
     {
        IF (X_LEVEL > 128)
        {
          WIDTH = WIDTH + 3
          MOVE_X = 1
        }
        ELSE IF (X_LEVEL < 128)
        {
          WIDTH = WIDTH - 3
          MOVE_X = 1
        }
        ELSE MOVE_X = 0

        IF (Y_LEVEL> 128)
        {
          MOVE_Y = 1
          HEIGHT = HEIGHT + 3
        }
        ELSE IF (Y_LEVEL < 128)
        {
          MOVE_Y = 1
          HEIGHT = HEIGHT - 3
        }
        ELSE MOVE_Y = 0
     }
     ACTIVE (ACTION = MOVE_LEFT):
     IF (X_POS > 5)
     {
        X_POS = X_POS - 5
        MOVE_X = 1
        MOVE_Y = 0
     }
     ACTIVE (ACTION = MOVE_RIGHT):
     IF (X_POS < TOTAL_WIDTH)
     {
        X_POS = X_POS + 5
        MOVE_X = 1
        MOVE_Y = 0
     }
     ACTIVE (ACTION = MOVE_DOWN) :
     IF (Y_POS < TOTAL_HEIGHT)
     {
        Y_POS = Y_POS + 5
        MOVE_Y = 1
        MOVE_X = 0
     }
     ACTIVE (ACTION = MOVE_UP)  :
     IF (Y_POS > 5)
     {
        Y_POS = Y_POS - 5
        MOVE_Y = 1
        MOVE_X = 0
     }
     ACTIVE (ACTION = ZOOM_OUT) :
     {
        FRZ[WINDOW] = 0
        MOVE_X = 0
        MOVE_Y = 0
        IF ((OLD_WSR_WIDTH < 65000))
           OLD_WSR_WIDTH  = WSR_WIDTH + 5
        IF ((OLD_WSR_HEIGHT < 65000))
           OLD_WSR_HEIGHT = WSR_HEIGHT + 5
     }
     ACTIVE (ACTION = ZOOM_IN)  :
     {
        FRZ[WINDOW] = 0
        MOVE_X = 0
        MOVE_Y = 0
        IF ((OLD_WSR_WIDTH > 5) && (WSR_WIDTH < 65000))
           OLD_WSR_WIDTH  = OLD_WSR_WIDTH - 5
        IF ((OLD_WSR_HEIGHT > 5) && (OLD_WSR_HEIGHT < 65000))
           OLD_WSR_HEIGHT = OLD_WSR_HEIGHT - 5
     }
  }

  IF (ACTION)
  {
    IF (ACTION = RESIZE)
    {
       DATA_STR = "ITOA(WINDOW),' ',ITOA(X_POS),' ',ITOA(Y_POS),' ',
                   ITOA(WIDTH),' ',ITOA(HEIGHT)"
       CALL 'SVWIN00F' (SuperView,WSR,DATA_STR,0)
    }
    ELSE IF (ACTION = ZOOM_IN    OR ACTION = ZOOM_OUT  OR
             ACTION = MOVE_RIGHT OR ACTION = MOVE_LEFT OR
             ACTION = MOVE_DOWN  OR ACTION = MOVE_UP)
    {
       DATA_STR = "ITOA(WINDOW),' ',ITOA(X_POS),' ',ITOA(Y_POS),' ',
                   ITOA(OLD_WSR_WIDTH),' ',ITOA(OLD_WSR_HEIGHT)"
       CALL 'SVWIN00F' (SuperView,WSR,DATA_STR,0)
    }
    ELSE IF (ACTION = BRIGHT_DARK OR ACTION = BRIGHT_LIGHT)
    {
(*         IF (ACTION = BRIGHT_DARK)
            BRI_LEVEL[WINDOW] = BRI_LEVEL[WINDOW] - 1
         ELSE
            BRI_LEVEL[WINDOW] = BRI_LEVEL[WINDOW] + 1
      CALL 'SVWIN00F' (SuperView,BRIGHT,"ITOA(WINDOW),' ',ITOA(BRI_LEVEL[WINDOW])",0)*)
    }
    ELSE IF (ACTION = MOVE_WINDOW_UP)
    {
       SETTINGS[WINDOW][WDR_Y_POS] = SETTINGS[WINDOW][WDR_Y_POS]-PIXEL_JUMP
       CALL 'Setup Coords' (WINDOW,SETTINGS[WINDOW][WDR_X_POS],SETTINGS[WINDOW][WDR_Y_POS],
                                   SETTINGS[WINDOW][WDR_WIDTH],SETTINGS[WINDOW][WDR_HEIGHT],DATA_STR)
       CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)
    }
    ELSE IF (ACTION = MOVE_WINDOW_DOWN)
    {
       SETTINGS[WINDOW][WDR_Y_POS] = SETTINGS[WINDOW][WDR_Y_POS]+PIXEL_JUMP
       CALL 'Setup Coords' (WINDOW,SETTINGS[WINDOW][WDR_X_POS],SETTINGS[WINDOW][WDR_Y_POS],
                                   SETTINGS[WINDOW][WDR_WIDTH],SETTINGS[WINDOW][WDR_HEIGHT],DATA_STR)
       CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)
    }
    ELSE IF (ACTION = MOVE_WINDOW_LEFT)
    {
       CALL 'SLIDE WINDOW LEFT' (SuperView,WINDOW)
    }
    ELSE IF (ACTION = MOVE_WINDOW_RIGHT)
    {
       CALL 'SLIDE WINDOW RIGHT' (SuperView,WINDOW)
    }
    ELSE IF (ACTION = RESIZE_BIG_4TO3)
    {
        (* MAINTAINS OUTPUT 4:3 RATIO *)
        CALL 'RESIZE BIGGER 4TO3' (SuperView,WINDOW)
    }
    ELSE IF (ACTION = RESIZE_SMALL_4TO3)
    {
        SETTINGS[WINDOW][WDR_WIDTH]  = SETTINGS[WINDOW][WDR_WIDTH]-PIXEL_JUMP 
        SETTINGS[WINDOW][WDR_HEIGHT] = ((SETTINGS[WINDOW][WDR_WIDTH] * 3) / 4)
        CALL 'Setup Coords' (WINDOW,SETTINGS[WINDOW][WDR_X_POS],SETTINGS[WINDOW][WDR_Y_POS],
                                   SETTINGS[WINDOW][WDR_WIDTH],SETTINGS[WINDOW][WDR_HEIGHT],DATA_STR)
        CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)
    }
    ELSE IF (ACTION = RESIZE_BIG_16TO9)
    {
        SETTINGS[WINDOW][WDR_WIDTH]  = SETTINGS[WINDOW][WDR_WIDTH]+PIXEL_JUMP 
        SETTINGS[WINDOW][WDR_HEIGHT] = ((SETTINGS[WINDOW][WDR_WIDTH] * 9) / 16)
        CALL 'Setup Coords' (WINDOW,SETTINGS[WINDOW][WDR_X_POS],SETTINGS[WINDOW][WDR_Y_POS],
                                   SETTINGS[WINDOW][WDR_WIDTH],SETTINGS[WINDOW][WDR_HEIGHT],DATA_STR)
        CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)
    }
    ELSE IF (ACTION = RESIZE_SMALL_16TO9)
    {
        SETTINGS[WINDOW][WDR_WIDTH]  = SETTINGS[WINDOW][WDR_WIDTH]-PIXEL_JUMP 
        SETTINGS[WINDOW][WDR_HEIGHT] = ((SETTINGS[WINDOW][WDR_WIDTH] * 9) / 16)
        CALL 'Setup Coords' (WINDOW,SETTINGS[WINDOW][WDR_X_POS],SETTINGS[WINDOW][WDR_Y_POS],
                                   SETTINGS[WINDOW][WDR_WIDTH],SETTINGS[WINDOW][WDR_HEIGHT],DATA_STR)
        CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)
    }
    
  }
}


(* Arrange *)
PUSH[TP,20]                        (* Preset 1 *)
{
(*  PRESET = 1
  WINDOW = 1
  LAST_COMMAND[WINDOW] = PRIORITY
  CALL 'Setup Coords' (1,0,0,MAIN_WIDTH,MAIN_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (2,MAIN_WIDTH,0,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (3,MAIN_WIDTH,SINGLE_HEIGHT,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (4,MAIN_WIDTH,MAIN_HEIGHT,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'SVWIN00F' (SuperView,SET_WINDOW_ALL,"'on on on on'",0)
  CALL 'SVWIN00F' (SuperView,PRIORITY,"ITOA(WINDOW),' 1'",0)

*)
  CALL 'SVWIN00F' (SuperView,SET_WINDOW_ALL,"'ON'",0)
  CALL 'SVWIN00F' (SuperView,SET_WINDOW,"'6 OFF'",0)

  SETTINGS[1][WDR_X_POS] = 0
  SETTINGS[1][WDR_Y_POS] = 0
  SETTINGS[1][WDR_WIDTH] = TOTAL_WIDTH
  SETTINGS[1][WDR_HEIGHT] = TOTAL_HEIGHT
  CALL 'Setup Coords' (1,0,0,TOTAL_WIDTH,TOTAL_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)
  
  SETTINGS[5][WDR_X_POS] = 64900
  SETTINGS[5][WDR_Y_POS] = 0
  SETTINGS[5][WDR_WIDTH] = TOTAL_WIDTH/3
  SETTINGS[5][WDR_HEIGHT] = TOTAL_HEIGHT/3
  CALL 'Setup Coords' (5,64900,0,TOTAL_WIDTH/3,TOTAL_HEIGHT/3,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)
  
  SETTINGS[2][WDR_X_POS] = TOTAL_WIDTH
  SETTINGS[2][WDR_Y_POS] = 0
  SETTINGS[2][WDR_WIDTH] = TOTAL_WIDTH/3
  SETTINGS[2][WDR_HEIGHT] = TOTAL_HEIGHT/3
  CALL 'Setup Coords' (2,TOTAL_WIDTH,0,TOTAL_WIDTH/3,TOTAL_HEIGHT/3,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  SETTINGS[3][WDR_X_POS] = 64900
  SETTINGS[3][WDR_Y_POS] = TOTAL_HEIGHT/2
  SETTINGS[3][WDR_WIDTH] = TOTAL_WIDTH/3
  SETTINGS[3][WDR_HEIGHT] = TOTAL_HEIGHT/3
  CALL 'Setup Coords' (3,64900,TOTAL_HEIGHT/2,TOTAL_WIDTH/3,TOTAL_HEIGHT/3,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  SETTINGS[4][WDR_X_POS] = TOTAL_WIDTH
  SETTINGS[4][WDR_Y_POS] = TOTAL_HEIGHT/2
  SETTINGS[4][WDR_WIDTH] = TOTAL_WIDTH/3
  SETTINGS[4][WDR_HEIGHT] = TOTAL_HEIGHT/3
  CALL 'Setup Coords' (4,TOTAL_WIDTH,TOTAL_HEIGHT/2,TOTAL_WIDTH/3,TOTAL_HEIGHT/3,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'SVWIN00F' (SuperView,PRIORITY,'1 6',0)
  
(* MOVEMENT *)
  WHILE (SETTINGS[5][WDR_X_POS] < 50 || SETTINGS[5][WDR_X_POS] > 60000)
  {
     CALL 'SLIDE WINDOW RIGHT' (SuperView,5)
  }
  WHILE (SETTINGS[2][WDR_X_POS] > ((TOTAL_WIDTH-SETTINGS[2][WDR_WIDTH])-50) )
  {
     CALL 'SLIDE WINDOW LEFT' (SuperView,2)
  }
  WHILE (SETTINGS[3][WDR_X_POS] < 50 || SETTINGS[3][WDR_X_POS] > 60000)
  {
     CALL 'SLIDE WINDOW RIGHT' (SuperView,3)
  }
  WHILE (SETTINGS[4][WDR_X_POS] > ((TOTAL_WIDTH-SETTINGS[4][WDR_WIDTH])-50) )
  {
     CALL 'SLIDE WINDOW LEFT' (SuperView,4)
  }


}

[TP,20] = (PRESET = 1)
PUSH[TP,21]                        (* Preset 2 *)
{
(*  PRESET = 2
  WINDOW = 1
  LAST_COMMAND[WINDOW] = PRIORITY
  CALL 'Setup Coords' (1,SINGLE_WIDTH,SINGLE_HEIGHT,MAIN_WIDTH,MAIN_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (2,0,MAIN_HEIGHT,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (3,0,SINGLE_HEIGHT,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (4,0,0,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'SVWIN00F' (SuperView,SET_WINDOW_ALL,"'on on on on'",0)
  CALL 'SVWIN00F' (SuperView,PRIORITY,"ITOA(WINDOW),' 1'",0)
  IF (WINDOW)
  {
    LAST_COMMAND[WINDOW] = WSR
    CALL 'SVWIN00F' (SuperView,WSR,"ITOA(WINDOW)",0)
  } *)
  
  PRESET = 2
  WINDOW = 1
  CALL 'SVWIN00F' (SuperView,SET_WINDOW_ALL,"'on on on on'",0)
  CALL 'SVWIN00F' (SuperView,PRIORITY,"ITOA(WINDOW),' 1'",0)

  CALL 'Setup Coords' (1,0,0,MAIN_WIDTH,MAIN_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (2,MAIN_WIDTH,0,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (3,MAIN_WIDTH,SINGLE_HEIGHT,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (4,MAIN_WIDTH,MAIN_HEIGHT,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (5,SINGLE_WIDTH,MAIN_HEIGHT,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (6,0,MAIN_HEIGHT,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)
}
PUSH[TP,22]                        (* Preset 3 *)
{
(*  PRESET = 3
  WINDOW = 1
  LAST_COMMAND[WINDOW] = PRIORITY
  CALL 'Setup Coords' (1,0,0,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (2,TOTAL_WIDTH/2,0,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (3,0,TOTAL_HEIGHT/2,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (4,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'SVWIN00F' (SuperView,SET_WINDOW_ALL,"'on on on on'",0)
  CALL 'SVWIN00F' (SuperView,PRIORITY,"ITOA(WINDOW),' 1'",0)
  IF (WINDOW)
  {
    LAST_COMMAND[WINDOW] = WSR
    CALL 'SVWIN00F' (SuperView,WSR,"ITOA(WINDOW)",0)
  } *)
  PRESET = 3
  WINDOW = 1
  CALL 'SVWIN00F' (SuperView,SET_WINDOW_ALL,"'on on on on'",0)
  CALL 'SVWIN00F' (SuperView,SET_WINDOW,"'1 OFF'",0)
  CALL 'SVWIN00F' (SuperView,PRIORITY,"'6 1'",0)

(*  CALL 'Setup Coords' (1,TOTAL_WIDTH/4,TOTAL_HEIGHT/4,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0) *)
  SETTINGS[6][WDR_X_POS]  = TOTAL_WIDTH/4
  SETTINGS[6][WDR_Y_POS]  = TOTAL_HEIGHT/4
  SETTINGS[6][WDR_WIDTH]  = 80
  SETTINGS[6][WDR_HEIGHT] = 80
  CALL 'Setup Coords' (6,TOTAL_WIDTH/4,TOTAL_HEIGHT/4,0,0,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  SETTINGS[2][WDR_X_POS]  = 0
  SETTINGS[2][WDR_Y_POS]  = 0
  SETTINGS[2][WDR_WIDTH]  = TOTAL_WIDTH/2
  SETTINGS[2][WDR_HEIGHT] = TOTAL_HEIGHT/2
  CALL 'Setup Coords' (2,0,0,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  SETTINGS[3][WDR_X_POS]  = TOTAL_WIDTH/2
  SETTINGS[3][WDR_Y_POS]  = 0
  SETTINGS[3][WDR_WIDTH]  = TOTAL_WIDTH/2
  SETTINGS[3][WDR_HEIGHT] = TOTAL_HEIGHT/2
  CALL 'Setup Coords' (3,TOTAL_WIDTH/2,0,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  SETTINGS[4][WDR_X_POS]  = 0
  SETTINGS[4][WDR_Y_POS]  = TOTAL_HEIGHT/2
  SETTINGS[4][WDR_WIDTH]  = TOTAL_WIDTH/2
  SETTINGS[4][WDR_HEIGHT] = TOTAL_HEIGHT/2
  CALL 'Setup Coords' (4,0,TOTAL_HEIGHT/2,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)
  
  SETTINGS[5][WDR_X_POS]  = TOTAL_WIDTH/2
  SETTINGS[5][WDR_Y_POS]  = TOTAL_HEIGHT/2
  SETTINGS[5][WDR_WIDTH]  = TOTAL_WIDTH/2
  SETTINGS[5][WDR_HEIGHT] = TOTAL_HEIGHT/2
  CALL 'Setup Coords' (5,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  WAIT 20 (* MOVEMENT *)
  {
    WHILE (SETTINGS[6][WDR_WIDTH] < TOTAL_WIDTH/2)
    {
       CALL 'RESIZE BIGGER 4TO3' (SuperView,6)
    }
  }
}
PUSH[TP,23]                        (* Preset 4 *)
{
  PRESET = 4
  WINDOW = 1
  LAST_COMMAND[WINDOW] = PRIORITY
  CALL 'Setup Coords' (1,SINGLE_WIDTH,0,MAIN_WIDTH,MAIN_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (2,MAIN_WIDTH,MAIN_HEIGHT,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (3,SINGLE_WIDTH,MAIN_HEIGHT,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (4,0,MAIN_HEIGHT,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'SVWIN00F' (SuperView,SET_WINDOW_ALL,"'on on on on'",0)
  CALL 'SVWIN00F' (SuperView,PRIORITY,"ITOA(WINDOW),' 1'",0)
  IF (WINDOW)
  {
    LAST_COMMAND[WINDOW] = WSR
    CALL 'SVWIN00F' (SuperView,WSR,"ITOA(WINDOW)",0)
  }
}
PUSH[TP,24]                        (* Preset 5 *)
{
  PRESET = 5
  WINDOW = 1
  LAST_COMMAND[WINDOW] = PRIORITY
  CALL 'Setup Coords' (1,0,SINGLE_WIDTH,MAIN_WIDTH,MAIN_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (2,0,0,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (3,SINGLE_WIDTH,0,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (4,MAIN_WIDTH,0,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'SVWIN00F' (SuperView,SET_WINDOW_ALL,"'on on on on'",0)
  CALL 'SVWIN00F' (SuperView,PRIORITY,"ITOA(WINDOW),' 1'",0)
  IF (WINDOW)
  {
    LAST_COMMAND[WINDOW] = WSR
    CALL 'SVWIN00F' (SuperView,WSR,"ITOA(WINDOW)",0)
  }
}
PUSH[TP,25]                        (* Preset 6 *)
{
  PRESET = 6
  WINDOW = 1
  LAST_COMMAND[WINDOW] = PRIORITY
  CALL 'Setup Coords' (1,TOTAL_WIDTH/4,TOTAL_HEIGHT/4,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (2,0,0,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (3,TOTAL_WIDTH/2,0,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'Setup Coords' (4,0,TOTAL_HEIGHT/2,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'SVWIN00F' (SuperView,SET_WINDOW_ALL,"'on on on on'",0)
  CALL 'SVWIN00F' (SuperView,PRIORITY,"ITOA(WINDOW),' 1'",0)
  IF (WINDOW)
  {
    LAST_COMMAND[WINDOW] = WSR
    CALL 'SVWIN00F' (SuperView,WSR,"ITOA(WINDOW)",0)
  }
}
[TP,20] = (PRESET = 1)
[TP,21] = (PRESET = 2)
[TP,22] = (PRESET = 3)
[TP,23] = (PRESET = 4)
[TP,24] = (PRESET = 5)
[TP,25] = (PRESET = 6)



(* INPUT ADJUST *)
PUSH[TP,30] (* CALL FOR INPUT ADJUST MENU *)
{
  ACTION = INPUT_ADJUST
  CLEAR_BUFFER SV_BUFFER
  CALL 'SVWIN00F' (SuperView,BRIGHT,"ITOA(WINDOW)",0)  
}

PUSH[TP,31] (* BRIGHTNESS DARKER *)
  ACTION = BRIGHT_DARK
[TP,31]= (ACTION = BRIGHT_DARK)
PUSH[TP,32] (* BRIGHTNESS LIGHTER *)
  ACTION = BRIGHT_LIGHT
[TP,32]= (ACTION = BRIGHT_LIGHT)

RELEASE[TP,31]
RELEASE[TP,32]
  ACTION = 0

RELEASE[TP,33] (* BAR GRAPH FOR BRIGHTNESS *)
{
  X = (MOVE_BRI * 4)
  IF (X < 510)
    BRI_LEVEL[WINDOW] = "'-',ITOA( (510-X) )"
  ELSE
    BRI_LEVEL[WINDOW] = ITOA( (X-510) )
  CALL 'SVWIN00F' (SuperView,BRIGHT,"ITOA(WINDOW),' ',BRI_LEVEL[WINDOW]",0)
  SEND_COMMAND TP,"'!T',3,BRI_LEVEL[WINDOW]"
}
[TP,33]= 0

RELEASE[TP,34] (* BAR GRAPH FOR CONTRAST *)
{
  X_CONTRAST = MOVE_CONTRAST
  CALL 'SVWIN00F' (SuperView,CONTRAST,"ITOA(WINDOW),' ',ITOA(X_CONTRAST)",0)
  SEND_COMMAND TP,"'!T',4,ITOA(X_CONTRAST)"
}
(*[TP,33]= X*)

RELEASE[TP,35] (* BAR GRAPH FOR SATURATION *)
{
  X = MOVE_SATURATION
  CALL 'SVWIN00F' (SuperView,SATURATION,"ITOA(WINDOW),' ',ITOA(X)",0)
  SEND_COMMAND TP,"'!T',5,ITOA(X)"
}
(*[TP,33]= X*)

RELEASE[TP,36] (* BAR GRAPH FOR HUE *)
{
  X = MOVE_HUE
  CALL 'SVWIN00F' (SuperView,HUE,"ITOA(WINDOW),' ',ITOA(X)",0)
  SEND_COMMAND TP,"'!T',6,ITOA(X)"
}
(*[TP,33]= X*)

PUSH[TP,40] (* MOVE WINDOW UP *)
  ACTION = MOVE_WINDOW_UP
[TP,40]= (ACTION = MOVE_WINDOW_UP)
PUSH[TP,41] (* MOVE_WINDOW_RIGHT *)
  ACTION = MOVE_WINDOW_RIGHT
[TP,41]= (ACTION = MOVE_WINDOW_RIGHT)
PUSH[TP,42] (* MOVE WINDOW DOWN *)
  ACTION = MOVE_WINDOW_DOWN
[TP,42]= (ACTION = MOVE_WINDOW_DOWN)
PUSH[TP,43] (* MOVE WINDOW LEFT *)
  ACTION = MOVE_WINDOW_LEFT
[TP,43]= (ACTION = MOVE_WINDOW_LEFT)

RELEASE[TP,40]
RELEASE[TP,41]
RELEASE[TP,42]
RELEASE[TP,43]
  ACTION = 0

PUSH[TP,44] (* RESIZE BIGGER IN 16 TO 9 RATIO *)
  ACTION = RESIZE_BIG_16TO9
[TP,44]= (ACTION = RESIZE_BIG_16TO9)
PUSH[TP,45] (* RESIZE BIGGER IN 4 TO 3 RATIO *)
  ACTION = RESIZE_BIG_4TO3
[TP,45]= (ACTION = RESIZE_BIG_4TO3)
PUSH[TP,46] (* RESIZE SMALLER IN 16 TO 9 RATIO *)
  ACTION = RESIZE_SMALL_16TO9
[TP,46]= (ACTION = RESIZE_SMALL_16TO9)
PUSH[TP,47] (* RESIZE SMALLER IN 4 TO 3 RATIO *)
  ACTION = RESIZE_SMALL_4TO3
[TP,47]= (ACTION = RESIZE_SMALL_4TO3)

RELEASE[TP,44]
RELEASE[TP,45]
RELEASE[TP,46]
RELEASE[TP,47]
  ACTION = 0


PUSH[TP,200]                       (* Maximize *)
IF(WINDOW)
{
  PULSE[TP,200]
  CALL 'SVWIN00F' (SuperView,PRIORITY,"ITOA(WINDOW),' 1'",0)
  CALL 'Setup Coords' (WINDOW,0,0,TOTAL_WIDTH,TOTAL_HEIGHT,DATA_STR)
  LAST_COMMAND[WINDOW] = WDR
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)
}

(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)

